<?php
require_once "validator/NotEmpty.class.php";
require_once "validator/MaxLength.class.php";

/**
 * 󥯥饹
 *
 * @package    peewee.framework
 * @author     rds <tk@rasign.jp>
 * @license    http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version    Release: 1.0.0
 * @link       http://peewee.rasign.jp/
 */
class Action{
    /**
     * @var    $errors
     * @access public
     */
	public $errors = null;

    /**
     * ¹ԥ᥽å
     *
     * @access public
     */
    public function execute(){
		if($_SERVER{"REQUEST_METHOD"} == "GET"){
			$this->get();
		}else{
		    $article = simplexml_load_file('config/validator.xml');

			$validatorMapping = array();
			foreach($article->mapping->validator as $item) {
				$validatorMapping[(String)$item->name] = (String)$item->class;
				$validatorMapping[(String)$item->name . "_errormessage"] = (String)$item->errormessage;
			}

			$validatorArray = array();
			foreach($article->items->item as $item) {
				foreach($item->attributes() as $a => $classvaliable) {
					$validatorArray[(String)$classvaliable] = "";

					foreach($item->validator as $validator) {
						$vps = array();
						foreach($validator->attributes() as $a2 => $b2) {
							$vp = array();

							foreach($validator->param as $param){
								foreach($param->attributes() as $a3 => $b3){
									$vp[(String)$b3] = (String)$param;
								}
							}
							
							$errorParam = array();
							foreach($validator->errorparam as $errorparam){
								$errorParam[] = (String)$errorparam;
							}
							$vp["errorparams"] = $errorParam;

							$validatorArray[(String)$classvaliable][(String)$b2] = $vp;
						}
					}
				}
			}

			$className =  get_class($this);
			$valiableArray = get_class_vars(get_class($this));

			$validatorChain = array();
			foreach($valiableArray as $key => $value){
				if(in_array($className . "." . $key, array_keys($validatorArray))){
					$aArray = $validatorArray[$className . "." . $key];

					foreach($aArray as $key2=>$value2){
						$validatorClass = new $validatorMapping[$key2]($this->$key ,$aArray[$key2], $validatorMapping[$key2 . "_errormessage"]);
						$validatorChain[] = $validatorClass;
					}
				}
			}


			$errors = "";
			for($i = 0; $i < count($validatorChain); $i++){
				$validator = $validatorChain[$i];
				if(!$validator->check()){
					$errors .= $validator->getErrorMessage() . "<br>";
				}
			}

			if(empty($errors) || $errors.length != 0){
				$this->post();
			}else{
				$this->errors = $errors;
			}
		}
	}

    /**
     * GET᥽å<br>
	 * GETꥯȤȤư롣
     *
     * @access public
     */
	public function get(){
	}

    /**
     * POST᥽å<br>
	 * POSTꥯȤȤư롣
     *
     * @access public
     */
	public function post(){
	}
}
?>
